"""
Zserio Python runtime library version |version|.

It implements all functionality needed by Zserio code generated by Python extension.

Furthermore, it provides the following convenient functionality for generated Zserio objects which can be
called by applications:

- Serialization (:obj:`zserio.serialization` module)
- Debug string output (:obj:`zserio.debugstring` module)
"""

from zserio.bitbuffer import BitBuffer
from zserio.bitreader import BitStreamReader
from zserio.bitwriter import BitStreamWriter
from zserio.creator import ZserioTreeCreator
from zserio.exception import PythonRuntimeException
from zserio.service import ServiceData, ServiceInterface, ServiceClientInterface, ServiceException
from zserio.pubsub import PubsubInterface, PubsubException
from zserio.json import JsonWriter, JsonReader
from zserio.walker import (WalkObserver, WalkFilter, Walker, DefaultWalkObserver, DepthWalkFilter,
                           RegexWalkFilter, ArrayLengthWalkFilter, AndWalkFilter)

from zserio.serialization import (serialize, deserialize, serialize_to_bytes, deserialize_from_bytes,
                                  serialize_to_file, deserialize_from_file)
from zserio.debugstring import (to_json_stream, to_json_string, to_json_file,
                                from_json_stream, from_json_string, from_json_file)

from zserio import array
from zserio import bitbuffer
from zserio import bitfield
from zserio import bitposition
from zserio import bitreader
from zserio import bitsizeof
from zserio import bitwriter
from zserio import builtin
from zserio import creator
from zserio import debugstring
from zserio import exception
# from zserio import float is omitted intentionally because of pylint error (redefined-builtin)
from zserio import hashcode
from zserio import json
from zserio import limits
from zserio import pubsub
from zserio import serialization
from zserio import service
from zserio import typeinfo
from zserio import walker


#: Zserio Python runtime library version string.
VERSION_STRING = "2.9.0"

"""
Zserio runtime library extension built in PyPi package.
"""

from zserio.compiler import JavaNotFoundException, run_compiler, generate
